<template>
  <b-container class="h-75">
    <h2>VOS MESSAGES</h2>
    <div class="d-flex">
      <ul
        v-if="discussions.length > 0"
        class="border w-25 p-2"
      >
        <li
          v-for="discussion in discussions"
          :key="discussion"
        >
          <NomVendeur
            v-if="discussion.de_utilisateur_id != store.user.id"
            :id="discussion.de_utilisateur_id"
            :message="true"
            :texte-message="discussion.message"
            :non-l-u="discussion.non_lu"
          />
          <NomVendeur
            v-else
            :id="discussion.a_utilisateur_id"
            :message="true"
            :texte-message="discussion.message"
            :non-l-u="false"
          />
        </li>
        <li v-if="newDiscussion != ''">
          <NomVendeur
            v-if="newDiscussion.utilisateurB.id != store.user.id"
            :id="newDiscussion.utilisateurB.id"
            :message="true"
            :texte-message="newDiscussion.message"
            :non-l-u="newDiscussion.non_lu"
          />
          <NomVendeur
            v-else
            :id="newDiscussion.utilisateurA.id"
            :message="true"
            :texte-message="newDiscussion.message"
            :non-l-u="newDiscussion.non_lu"
          />
        </li>
      </ul>
      <div
        v-else
        class="border w-25 p-2"
      >
        Vous n'avez pas d'historique de discussion
      </div>
      <!-- si discusison sélectionnée -->
      <div
        v-if="$route.params.destinataireid"
        class="w-75 p-4"
      >
        <NomVendeur
          :id="$route.params.destinataireid"
          :message="true"
        />
        <p v-if="idDiscussion == false">
          Envoyer un message pour débuter la conversation.
        </p>
        <div v-else>
          <div
            v-for="msg in messages"
            :key="msg"
          >
            <p
              v-if="msg.de_utilisateur_id == store.user.id"
              class="message current_user"
            >
              {{ msg.message }}
            </p>
            <p
              v-else-if="msg.de_utilisateur == '/api/utilisateurs/' + store.user.id"
              class="message current_user"
            >
              {{ msg.message }}
            </p>
            <p
              v-else
              class="message other_user"
            >
              {{ msg.message }}
            </p>
          </div>
        </div>
        <b-form 
          class="d-flex form-inline my-2 my-lg-0 w-75 border w-100"
          @submit="onSubmit"
        >
          <b-form-input
            id="input-1"
            v-model="form.mess"
            class="form-control mr-sm-2 border-0"
            placeholder="Aa..."
            aria-label="champ message"
            required
          />
          <button
            class="border-0 btn-envoyer"
            type="submit"
          >
            <svg
              xmlns="http://www.w3.org/2000/svg"
              xmlns:xlink="http://www.w3.org/1999/xlink"
              width="26px"
              height="26px"
              viewBox="0 0 26 26"
              version="1.1"
            >
              <g id="surface1">
                <path
                  style="fill:none;stroke-width:1.5;stroke-linecap:round;stroke-linejoin:round;stroke:rgb(0%,10.196078%,44.705882%);stroke-opacity:1;stroke-miterlimit:4;"
                  d="M 31.998498 1.001502 L 1.001502 13.763221 L 13.763221 19.236779 L 19.236779 31.998498 Z M 31.998498 1.001502 "
                  transform="matrix(0.787879,0,0,0.787879,0,0)"
                />
                <path
                  style="fill:none;stroke-width:1.5;stroke-linecap:round;stroke-linejoin:round;stroke:rgb(0%,10.196078%,44.705882%);stroke-opacity:1;stroke-miterlimit:4;"
                  d="M 31.998498 1.001502 L 13.763221 19.236779 "
                  transform="matrix(0.787879,0,0,0.787879,0,0)"
                />
              </g>
            </svg>
          </button>
        </b-form>
      </div>
      <!-- si pas de discussion choisie -->
      <div
        v-else
        class="border w-100 p-4"
      >
        <p>Aucune discussion sélectionnée.</p>
      </div>
    </div>
  </b-container>
</template>

<script>
import { useStore } from '@/store/store'
import axios from 'axios';
import NomVendeur from '@/components/NomVendeur.vue';
import { mapState } from 'pinia';


  export default {
    components: {
      NomVendeur
    },

    data() {
      return {
          discussions: [],
          newDiscussion: '',
          messages: [],
          store: useStore(),
          idDiscussion: '',
          form: {
            mess: ''
          },
          pseudoUser: '',
          url: process.env.VUE_APP_URL,
          idDestinataire: ''
      }
    },
    
    watch: {
        '$route.params.destinataireid': function () {
            this.loadData();
        },
    },

    computed: {
        ...mapState(useStore, ['user']),
    },

    mounted(){
      this.loadData();
      // on récupère les info du user à qui l'ont veut parler
      // if(this.$route.params.destinataireid){
      //   axios.get(this.url + "/api/info_vendeurs/" + this.$route.params.destinataireid)
      //   .then(res => { 
      //     this.idDestinataire = res.data.utilisateur.id;
      //     this.pseudoUser = res.data.utilisateur.pseudo;
      //     if(this.idDestinataire != '') {
      //       //on vérifie s'il existe déjà une discussion entre les 2 utilisateurs
      //       axios({
      //         method: 'get',
      //         url: this.url + "/api/isdiscussion/" + this.store.user.id + '/' + this.idDestinataire,
      //       })
      //       .then(res => {
      //         console.log(res.data);
      //         if(res.data['hydra:totalItems'] == 0){
      //           this.idDiscussion = false;
      //         } else {
      //           this.idDiscussion = res.data['hydra:member'][0].discussion_id;
      //           //on push les msg dans un array
      //           res.data['hydra:member'].forEach(message => {
      //             this.messages.push(message);
      //           })
      //         }
      //       })
      //       .catch(err => {
      //           console.log(err);
      //       });
      //     }
      //   })
      //   .catch(err => {
      //       console.log(err)
      //   })
      // }
      // //on récupère le listing de discussions du user
      // axios({
      //   method: 'get',
      //   url: this.url + "/api/alldiscussions/" + this.store.user.id,
      // })
      // .then(res => {
      //   let listing = res.data['hydra:member'];
      //   for (let i = 0; i < listing.length; i++) {
      //     let itemDiscussion = listing[i];
      //     this.discussions.push(itemDiscussion);
      //   }
      // })
      // .catch(err => {
      //   console.log(err);
      // });
      

    },

    methods: {
      loadData(){
        this.discussions = [];
        this.messages = [];

       // on récupère les info du user à qui l'ont veut parler
      if(this.$route.params.destinataireid){
        axios.get(this.url + "/api/utilisateurs/" + this.$route.params.destinataireid)
        .then(res => { 
          this.idDestinataire = res.data.id;
          this.pseudoUser = res.data.pseudo;
          if(this.idDestinataire != '') {
            //on vérifie s'il existe déjà une discussion entre les 2 utilisateurs
            axios({
              method: 'get',
              url: this.url + "/api/isdiscussion/" + this.store.user.id + '/' + this.idDestinataire,
            })
            .then(res => {
              if(res.data['hydra:totalItems'] == 0){
                this.idDiscussion = false;
              } else {
                this.idDiscussion = res.data['hydra:member'][0].discussion_id;
                //on push les msg dans un array
                res.data['hydra:member'].forEach(message => {
                  // si message non lu dans la BDD et que l'on est le destinataire du message, on le passe en 'lu'
                  if(message.a_utilisateur_id == this.store.user.id && message.non_lu == true){
                    axios.put(this.url + "/api/messages/" + message.id, {
                      "nonLu": false,
                    })
                    .then(response => {
                      this.loadData();
                    })    
                    .catch(err => {
                        console.log(err);
                    })
                  }
                  this.messages.push(message);
                })
              }
            })
            .catch(err => {
                console.log(err);
            });
          }
        })
        .catch(err => {
            console.log(err)
        })
      }
      //on récupère le listing de discussions du user
      axios({
        method: 'get',
        url: this.url + "/api/alldiscussions/" + this.store.user.id,
      })
      .then(res => {
        let listing = res.data['hydra:member'];
        for (let i = 0; i < listing.length; i++) {
          let itemDiscussion = listing[i];
          this.discussions.push(itemDiscussion);
        }
      })
      .catch(err => {
        console.log(err);
      });
      },

      onSubmit() {
        
        console.log(this.idDiscussion);
        //si pas encore de discussion entre les user on crée la discussion
        if(this.idDiscussion == false){
          axios.post(this.url + "/api/discussions", {
            "utilisateurA": "api/utilisateurs/" + this.store.user.id,
            "utilisateurB": "api/utilisateurs/" + this.idDestinataire,
          },
          {
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
          })
          .then(res => {
            this.idDiscussion = res.data.id;
            this.newDiscussion = res.data;
            this.send(this.idDiscussion);
          })
          .catch(err => {
              this.error =  err.response.data['hydra:description'];
              console.log(err);
          })
        } else {
          this.send(this.idDiscussion);
        }

        

      },

      send(id){
      //ensuite on envoie le message
      axios.post(this.url + "/api/messages", {
                "message": this.form.mess,
                "discussion": "api/discussions/" + id,
                "nonLu": true,
                "deUtilisateur": "api/utilisateurs/" + this.store.user.id,
                "aUtiliseur": "api/utilisateurs/" + this.idDestinataire
              },
              {
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json'
                },
              })
              .then(res => {
                this.messages.push(res.data);
                this.form.mess = ''; 
              })
              .catch(err => {
                  this.error =  err.response.data['hydra:description'];
                  console.log(err);
              })
      }
    }
  }
</script>

<style lang="scss" scoped>
  .btn-envoyer {
    background-color: #fff;
  }

  .message {
    border-radius: 15px;
    padding: 6px;
    width: fit-content;
    &.other_user {
      background-color: #E4E6EB;
      color: black;
    }
    &.current_user {
      background-color: rgb(0, 132, 255);
      color: white;
      margin-left: auto;
    }
  }
</style>